tinsert(CT_RABoss_ModsToLoad, "CT_RABossSarf_Tooltip_OnLoad");

CT_RABossSarf_Tooltip_AllMobs = false;
CT_RABossSarf_Tooltip_IsWarrior = true;
CT_RABossSarf_Tooltip_Enabled = true;
CT_RABossSarf_Tooltip_OnlyIfWarrior = false;
CT_RABossSarf_Tooltip_CurrentMap = "";

function CT_RABossSarf_Tooltip_OnLoad()
	--[[
	if ( not CT_RABossSarf_Tooltip_OnLoad_TooltipFunctions() ) then
		CT_RABoss_AddEvent("MT Tooltip", "UPDATE_MOUSEOVER_UNIT", CT_RABossSarf_Tooltip_EventHandler_MouseOver);
	end
	]]--
	
	--CT_RABoss_AddMod(CT_RA_BOSSMODS_SARF_TOOLTIP_NAME, CT_RA_BOSSMODS_SARF_TOOLTIP_NAME_INFO, 1, CT_RABOSS_LOCATIONS_ONYXIASLAIR);

	
	CT_RABoss_AddEvent("MT Tooltip", "UPDATE_MOUSEOVER_UNIT", CT_RABossSarf_Tooltip_EventHandler_MouseOver);

	CT_RABoss_AddEvent("MT Tooltip", "PLAYER_ENTERING_WORLD", CT_RABossSarf_Tooltip_EventHandler_Map);
	CT_RABoss_AddEvent("MT Tooltip", "WORLD_MAP_UPDATE", CT_RABossSarf_Tooltip_EventHandler_Map);
	CT_RABoss_AddEvent("MT Tooltip", "MINIMAP_ZONE_CHANGED", CT_RABossSarf_Tooltip_EventHandler_Map);
	CT_RABoss_AddEvent("MT Tooltip", "ZONE_CHANGED", CT_RABossSarf_Tooltip_EventHandler_Map);
	CT_RABoss_AddEvent("MT Tooltip", "ZONE_CHANGED_INDOORS", CT_RABossSarf_Tooltip_EventHandler_Map);
	CT_RABoss_AddEvent("MT Tooltip", "ZONE_CHANGED_NEW_AREA", CT_RABossSarf_Tooltip_EventHandler_Map);
end

function CT_RABossSarf_Tooltip_OnLoad_TooltipFunctions()
	if ( not TooltipFunctions ) or ( not TooltipFunctions.addHandler ) then
		return false;
	end
	TooltipsFunctions.addHandler ( 
	 	{	
	 		id="TankTargets", -- Custom ID unique to this handler
	 		func=function(type) -- Function called on unit mouseover
				CT_RABossSarf_Tooltip_EventHandler_MouseOver();
			end;
	 		text="Show MT targets", -- Checkbox text for that handler
	 		helptext="Show MT targets on mouseoer", -- Mouseover text for that handler
	 		default=true, -- default state (true/false)
	 		featureName="", -- String describing the feature "featureName enabled"
	 		keyword="tank" 	-- String keyword used for the /tooltip command
		}
 	);
 	return true;
end


function CT_RABossSarf_Tooltip_EventHandler_MouseOver(event)
	if ( not CT_RABossSarf_Tooltip_Enabled ) or ( not UnitExists("mouseover") ) 
		or ( not CT_RABossSarf_Tooltip_CurrentMap ) or ( UnitIsPlayer("mouseover") ) 
		or ( ( CT_RABossSarf_Tooltip_OnlyIfWarrior ) and ( not CT_RABossSarf_Tooltip_IsWarrior ) ) then
		return;
	end
	local mobs = CT_RA_BOSSMODS_SARF_TOOLTIP_TARGETED_MOBS[CT_RABossSarf_Tooltip_CurrentMap];
	if ( not CT_RABossSarf_Tooltip_AllMobs ) and ( ( not mobs ) or ( type(mobs) ~= "table" ) ) then
		return;
	end
	if ( ( CT_RABossSarf_Tooltip_AllMobs ) or ( mobs[UnitName("mouseover")] ) ) and ( CT_RATarget ) and ( CT_RATarget.MainTanks ) then
		local str = nil;
		for k, v in CT_RATarget.MainTanks do
			if ( UnitIsUnit("raid"..v[1].."target", "mouseover") ) then
				if ( str ) then
					str = str..", ";
				else
					str = "";
				end
				str = str..format(CT_RA_BOSSMODS_SARF_TOOLTIP_NAME_FORMAT, v[2]);
			end
		end
		if ( str ) then
			GameTooltip:AddLine(format(CT_RA_BOSSMODS_SARF_TOOLTIP_LINE_FORMAT, str));
			CT_RABossSarf_TooltipMouseoverFixSize();
		end
	end
end

function CT_RABossSarf_Tooltip_EventHandler_Map(event)
	if ( event == "PLAYER_ENTERING_WORLD" ) then
		local _, class = UnitClass("player");
		if ( class ~= "WARRIOR" ) then
			CT_RABossSarf_Tooltip_IsWarrior = false;
		end
	end
	CT_RABossSarf_Tooltip_CurrentMap = GetRealZoneText();
	if ( not CT_RABossSarf_Tooltip_CurrentMap ) then
		CT_RABossSarf_Tooltip_CurrentMap = "";
	end
end

-- Code ripped from TooltipsKhaos. All credits to that addon for it
	-- fix the size and remove blank lines
	-- note that blank lines can still be created by setting the string to ""
CT_RABossSarf_TooltipMouseoverFixSize = function()
	local tooltipName = "GameTooltip";
	local newWidth = 0;
	local newHeight = 20;
	local lastValid = 0;
	for i = 1, 20 do
		local checkLeftText = getglobal(tooltipName.."TextLeft"..i);
		local checkRightText = getglobal(tooltipName.."TextRight"..i);
		local width = TooltipsFunctions.GetTooltipLineWidth(checkLeftText, checkRightText);
		if (width) then
			if (width > newWidth) then
				newWidth = width;
			end
			newHeight = newHeight + checkLeftText:GetHeight() + 2;
			lastValid = lastValid + 1;
			if (lastValid ~= i) then
				local moveLeftText = getglobal(tooltipName.."TextLeft"..lastValid);
				local moveRightText = getglobal(tooltipName.."TextRight"..lastValid);
				if (moveLeftText ~= nil and checkLeftText ~= nil) then
					moveLeftText:SetText(checkLeftText:GetText());
					moveLeftText:SetTextColor(checkLeftText:GetTextColor());
					if (checkLeftText:IsVisible()) then 
						moveLeftText:Show();
					end
					checkLeftText:SetText("");
					checkLeftText:Hide();
				end
				if (moveRightText ~= nil and checkRightText~=nil) then
					moveRightText:SetText(checkRightText:GetText());
					moveRightText:SetTextColor(checkRightText:GetTextColor());
					if (checkRightText:IsVisible()) then 
						moveRightText:Show();
					end
					checkRightText:SetText("");
					checkRightText:Hide();
				end
			end
		end
	end

	GameTooltip:SetWidth(newWidth);
	GameTooltip:SetHeight(newHeight);
end
