tinsert(CT_RABoss_ModsToLoad, "CT_RABossSarf_BloodlordMandokir_OnLoad");

CT_RABossSarf_BloodlordMandokir_PreviousTarget = nil;
CT_RABossSarf_BloodlordMandokir_IsWatched = false;

CT_RABossSarf_BloodlordMandokir_FunctionNames = {
	CastPetAction = 1;
	UseAction = 1;
	CastSpell = 2;
	CastSpellByName = 2;
	UseInventoryItem = 1;
	UseContainerItem = 2;
	AttackTarget = 0;
	PetAttack = 0;
	TargetFrame_OnShow = 0;
};

function CT_RABossSarf_BloodlordMandokir_OnLoad()
	CT_RABoss_AddDropDownButton("Bloodlord Mandokir", { CT_RABOSSSARF_BLMANDOKIR_STOP, CT_RABOSSSARF_BLMANDOKIR_STOP_INFO }, "CT_RABoss_ModInfo", "stopOnWatch", "CT_RABoss_SetInfo");
	--CT_RABoss_AddEvent("Bloodlord Mandokir", "CHAT_MSG_MONSTER_YELL", CT_RABossSarf_BloodlordMandokir_EventHandler);
	CT_RABoss_AddEvent("Bloodlord Mandokir", "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS", CT_RABossSarf_BloodlordMandokir_EventHandler_Buff);
	CT_RABoss_AddEvent("Bloodlord Mandokir", "UNIT_AURA", CT_RABossSarf_BloodlordMandokir_EventHandler_Aura);
	CT_RABoss_SetVar("Bloodlord Mandokir", "stopOnWatch", true);

	local paramStr = nil;
	for k, v in CT_RABossSarf_BloodlordMandokir_FunctionNames do
		if ( not getglobal("CT_RABossSarf_Saved_"..k) ) then
			setglobal("CT_RABossSarf_Saved_"..k, getglobal(k));
			if ( not getglobal("CT_RABossSarf_"..k) ) then
				paramStr = "";
				if ( v > 0 ) then
					paramStr = paramStr.."p1";
				end
				for i = 2, v do paramStr = paramStr..",p"..i; end
				RunScript("function CT_RABossSarf_"..k.."("..paramStr..") if ( CT_RABossSarf_BloodlordMandokir_IsWatched ) then return; end return CT_RABossSarf_Saved_"..k.."("..paramStr.."); end");
			end
			setglobal(k, getglobal("CT_RABossSarf_"..k));
		end
	end
end

function CT_RABossSarf_TargetFrame_OnShow()
	if ( CT_RABossSarf_BloodlordMandokir_IsWatched ) then 
		ClearTarget(); 
		return;
	else
		return CT_RABossSarf_Saved_TargetFrame_OnShow();
	end
end

function CT_RABossSarf_BloodlordMandokir_EventHandler_Aura(event)
	if ( event == "UNIT_AURA" ) and ( arg1 == "player" ) then
		local gotAura = false;
		local debuff, str;
		for i = 1, MAX_TARGET_DEBUFFS do
			debuff = UnitDebuff("player", i);
			if ( debuff ) and ( debuff == CT_RABOSSMODS_SARF_MANDOKIR_WATCH_TEXTURE ) then
				CT_RATooltip:SetUnitDebuff("player", i);
				str = CT_RATooltipTextLeft1:GetText();
				if ( str == CT_RABOSSMODS_SARF_MANDOKIR_WATCH_NAME ) then
					gotAura = true;
					break;
				end
			else
				break;
			end
		end
		if ( gotAura ~= CT_RABossSarf_BloodlordMandokir_IsWatched ) then
			if ( gotAura ) then 
				CT_RABossSarf_BloodlordMandokir_AreWatching();
			else
				CT_RABossSarf_BloodlordMandokir_NoLongerWatching();
			end
		end
	end
end



function CT_RABossSarf_BloodlordMandokir_AreWatching()
	if ( not CT_RABoss_Mods["Bloodlord Mandokir"] or not CT_RABoss_Mods["Bloodlord Mandokir"]["status"] or not CT_RABoss_Mods["Bloodlord Mandokir"].enabled ) then
		return;
	end
	if ( CT_RABoss_Mods["Bloodlord Mandokir"]["stopOnWatch"] ) then
		CT_RABoss_Announce(CT_RABOSSSARF_BLMANDOKIR_MSG_STOP);
		CT_RABoss_PlaySound(2);
		CT_RABossSarf_BloodlordMandokir_PreviousTarget = UnitName("target");
		CT_RABossSarf_BloodlordMandokir_StopAttacking();
		CT_RABossSarf_BloodlordMandokir_StopCasting();
		CT_RABossSarf_BloodlordMandokir_IsWatched = true;
	end
end

function CT_RABossSarf_BloodlordMandokir_NoLongerWatching()
	CT_RABossSarf_BloodlordMandokir_IsWatched = false;
	if ( CT_RABossSarf_BloodlordMandokir_PreviousTarget ) then
		TargetByName(CT_RABossSarf_BloodlordMandokir_PreviousTarget);
		CT_RABossSarf_BloodlordMandokir_PreviousTarget = nil;
	end
end

function CT_RABossSarf_BloodlordMandokir_EventHandler(event)
	if ( not CT_RABoss_Mods["Bloodlord Mandokir"] or not CT_RABoss_Mods["Bloodlord Mandokir"]["status"] or not CT_RABoss_Mods["Bloodlord Mandokir"].enabled ) then
		return;
	end
	if ( event == "CHAT_MSG_MONSTER_YELL" ) and ( string.find(arg1, CT_RABOSS_MANDOKIR_REGEXP) ) and ( CT_RABoss_Mods["Bloodlord Mandokir"]["stopOnWatch"] ) then
		local iStart, iEnd, sPlayer = string.find(arg1, CT_RABOSS_MANDOKIR_REGEXP);
		if ( sPlayer ) and ( sPlayer == UnitName("player") ) then
			CT_RABossSarf_BloodlordMandokir_AreWatching();
			CT_RABoss_Schedule("CT_RABossSarf_BloodlordMandokir_NoLongerWatching", 6);
		end
	end
end

function CT_RABossSarf_BloodlordMandokir_StopAttacking()
	PetStopAttack();
	ClearTarget();
	return true;
end

function CT_RABossSarf_BloodlordMandokir_StopCasting()
	SpellStopCasting();
	SpellStopTargeting();
	return true;
end

CT_RABoss_BloodlordMandokir_WhirlwindWarning_Classes = {
	WARRIOR = true;
	ROGUE = true;
	PALADIN = true;
};

function CT_RABoss_BloodlordMandokir_EventHandler_Buff(event)
	if ( event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS" ) then
		local _, class = UnitClass("player");

		if ( CT_RABoss_BloodlordMandokir_WhirlwindWarning_Classes[class] ) 
			and ( strfind(arg1, CT_RABOSSSARF_BLMANDOKIR_FIND_WHIRLWIND ) ) then
			CT_RABoss_Announce(CT_RABOSSSARF_BLMANDOKIR_MSG_WHIRLWIND);
			CT_RABoss_PlaySound(3);
		end
	end
end